
package rageltest;

import java.awt.Color;
import java.awt.EventQueue;
import java.util.HashMap;
import java.util.Map;

import javax.swing.JFrame;

import org.fife.ui.rsyntaxtextarea.AbstractTokenMakerFactory;
import org.fife.ui.rsyntaxtextarea.RSyntaxTextArea;
import org.fife.ui.rsyntaxtextarea.Style;
import org.fife.ui.rsyntaxtextarea.SyntaxScheme;
import org.fife.ui.rsyntaxtextarea.TokenMakerFactory;

import static org.fife.ui.rsyntaxtextarea.Token.*;

public class Test extends JFrame {
	public Test () {
		System.setProperty(TokenMakerFactory.PROPERTY_DEFAULT_TOKEN_MAKER_FACTORY, TestFactory.class.getName());

		RSyntaxTextArea textArea = new RSyntaxTextArea();
		textArea.setSyntaxEditingStyle(TestFactory.SYNTAX_STYLE_TEST);

		SyntaxScheme scheme = new SyntaxScheme(true);
		scheme.setStyle(LITERAL_CHAR, new Style(Color.red, null));
		scheme.setStyle(OPERATOR, new Style(Color.green, null));
		textArea.setSyntaxScheme(scheme);

		setContentPane(textArea);
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		setSize(800, 600);
		setLocationRelativeTo(null);
		setVisible(true);
	}

	static public class TestFactory extends AbstractTokenMakerFactory {
		static public final String SYNTAX_STYLE_NONE = "none";
		static public final String SYNTAX_STYLE_TEST = "custom";

		protected Map createTokenMakerKeyToClassNameMap () {
			HashMap map = new HashMap();
			map.put(SYNTAX_STYLE_NONE, "org.fife.ui.rsyntaxtextarea.modes.PlainTextTokenMaker");
			map.put(SYNTAX_STYLE_TEST, TestTokenMaker.class.getName());
			return map;
		}
	}

	public static void main (String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run () {
				new Test();
			}
		});
	}
}
